/*
 * SimpleModal message Form
 * http://www.ericmmartin.com/projects/simplemodal/
 * http://code.google.com/p/simplemodal/
 *
 * Copyright (c) 2008 Eric Martin - http://ericmmartin.com
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Revision: $Id: message.js 132 2008-05-23 16:05:17Z emartin24 $
 *
 */
/*
$(document).ready(function () {
	$('#messageLink, #messageForm input:eq(0)').click(function (e) {
		e.preventDefault();
		// load the message form using ajax
		
		$.get("data/message.php",function(data){
			// create a modal dialog with the data
			$(data).modal({
				close: false,
				overlayId: 'message-overlay',
				containerId: 'message-container',
				onOpen: message.open,
				onShow: message.show,
				onClose: message.close
			});
		});
	});

	// preload images
	var img = ['cancel.png','form_bottom.gif','form_top.gif','form_top_ie.gif','loading.gif','send.png'];
	$(img).each(function () {
		var i = new Image();
		i.src = 'img/message/' + this;
	});
});
*/
var message = {
	message: null,
	open: function (dialog) {
		// add padding to the buttons in firefox/mozilla
		if ($.browser.mozilla) {
			$('#message-container .message-button').css({
				'padding-bottom': '2px'
			});
		}
		// input field font size
		if ($.browser.safari) {
			$('#message-container .message-input').css({
				'font-size': '.9em'
			});
		}

		var title = $('#message-container .message-title').html();
		$('#message-container .message-title').html('Loading...');
		dialog.overlay.fadeIn(200, function () {
			dialog.container.fadeIn(200, function () {
				dialog.data.fadeIn(200, function () {
					$('#message-container .message-content').animate({
						height: 260
					}, function () {
						$('#message-container .message-title').html(title);
						$('#message-container form').fadeIn(200, function () {
							$('#message-container #message-name').focus();

							// fix png's for IE 6
							if ($.browser.msie && $.browser.version < 7) {
								$('#message-container .message-button').each(function () {
									if ($(this).css('backgroundImage').match(/^url[("']+(.*\.png)[)"']+$/i)) {
										var src = RegExp.$1;
										$(this).css({
											backgroundImage: 'none',
											filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' +  src + '", sizingMethod="crop")'
										});
									}
								});
							}
						});
					});
				});
			});
		});
	},
	show: function (dialog) {
		$('#message-container .message-send').click(function (e) {
			e.preventDefault();
			// validate form
			if (message.validate()) {
				$('#message-container .message-message').fadeOut(function () {
					$('#message-container .message-message').removeClass('message-error').empty();
				});
				$('#message-container .message-title').html('Sending...');
				$('#message-container form').fadeOut(200);
				$('#message-container .message-content').animate({
					height: '80px'
				}, function () {
					$('#message-container .message-loading').fadeIn(200, function () {
						$.ajax({
							url: 'data/contact.php',
							data: $('#message-container form').serialize() + '&action=send',
							type: 'post',
							cache: false,
							dataType: 'html',
							complete: function (xhr) {
								$('#message-container .message-loading').fadeOut(200, function () {
									$('#message-container .message-title').html('Thank you!');
									$('#message-container .message-message').html(xhr.responseText).fadeIn(200);
								});
							},
							error: message.error
						});
					});
				});
			}
			else {
				if ($('#message-container .message-message:visible').length > 0) {
					var msg = $('#message-container .message-message div');
					msg.fadeOut(200, function () {
						msg.empty();
						message.showError();
						msg.fadeIn(200);
					});
				}
				else {
					$('#message-container .message-message').animate({
						height: '30px'
					}, message.showError);
				}
				
			}
		});
	}/*,
	close: function (dialog) {
		$('#message-container .message-message').fadeOut();
		$('#message-container .message-title').html('Goodbye...');
		$('#message-container form').fadeOut(200);
		$('#message-container .message-content').animate({
			height: 40
		}, function () {
			dialog.data.fadeOut(200, function () {
				dialog.container.fadeOut(200, function () {
					dialog.overlay.fadeOut(200, function () {
						$.modal.close();
					});
				});
			});
		});
	}*/,
	error: function (xhr) {
		alert(xhr.statusText);
	},
	validate: function () {
		message.message = '';
		if (!$('#message-container #message-name').val()) {
			message.message += '主旨 is required. ';
		}
/*
		var email = $('#message-container #message-email').val();
		if (!email) {
			message.message += 'Email is required. ';
		}
		else {
			if (!message.validateEmail(email)) {
				message.message += 'Email is invalid. ';
			}
		}
*/
		if (!$('#message-container #message-content').val()) {
			message.message += 'Message is required.';
		}

		if (message.message.length > 0) {
			return false;
		}
		else {
			return true;
		}
	}
	/*,
	
	validateEmail: function (email) {
		var at = email.lastIndexOf("@");

		// Make sure the at (@) sybmol exists and  
		// it is not the first or last character
		if (at < 1 || (at + 1) === email.length)
			return false;

		// Make sure there aren't multiple periods together
		if (/(\.{2,})/.test(email))
			return false;

		// Break up the local and domain portions
		var local = email.substring(0, at);
		var domain = email.substring(at + 1);

		// Check lengths
		if (local.length < 1 || local.length > 64 || domain.length < 4 || domain.length > 255)
			return false;

		// Make sure local and domain don't start with or end with a period
		if (/(^\.|\.$)/.test(local) || /(^\.|\.$)/.test(domain))
			return false;

		// Check for quoted-string addresses
		// Since almost anything is allowed in a quoted-string address,
		// we're just going to let them go through
		if (!/^"(.+)"$/.test(local)) {
			// It's a dot-string address...check for valid characters
			if (!/^[-a-zA-Z0-9!#$%*\/?|^{}`~&'+=_\.]*$/.test(local))
				return false;
		}

		// Make sure domain contains only valid characters and at least one period
		if (!/^[-a-zA-Z0-9\.]*$/.test(domain) || domain.indexOf(".") === -1)
			return false;	

		return true;
	}*/,
	showError: function () {
		$('#message-container .message-message')
			.html($('<div class="message-error">').append(message.message))
			.fadeIn(200);
	}
};